#include <3694.h>
#include <stdio.h>

// ܂ł̋LqƂ̂x̌݊ۂ߂̃}N
#define rs_init     SCI3_INIT
#define rs_rx_buff  SCI3_IN_DATA_CHECK
#define rs_tx_buff  SCI3_OUT_DATA_CHECK
#define rs_rx_purge SCI3_IN_DATA_CLEAR
#define rs_tx_purge SCI3_OUT_DATA_CLEAR
#define rs_putc     SCI3_OUT_DATA
#define rs_puts     SCI3_OUT_STRING
#define rs_putsb    SCI3_OUT_STRINGB
#define rs_getc     SCI3_IN_DATA
#define rs_gets     SCI3_IN_STRING
#define rs_printf   SCI3_PRINTF

// I/Os̒`
#define SEG7        IO.PDR5.BYTE
#define TWT         500
#define BWT         20000
#define dig         (5.0/1023.0)
#define SF          (-21.4900270)
#define OF           79.6786489
#define dof         1000
#define BEHOT       7
#define BECOOL      8
#define STOP        0

void init();
void twait(long time);
void diag_num(int mode,int num);
void get_temp(void);
void exec_relay(char num);

unsigned char onoff;                      // 1:\Ƃ 0:
unsigned char onset;                      // 1:ݒ胂[h 0:䃂[h
int temp_i;
int temp_d;                               // \p
int temp_c;                               // ݒp
int volt;
int temp;
char txb[10], rxb[10], buf[15];           // RS-232C ʐMpO[oϐ

int main()
{
  // ϐ錾
  char mode = 1;
  onset = onoff = 0;
  temp_c = 25;
  
  DI;                                     // 荞ݕs
  init();                                 // H8/3664F 
  EI;                                     // 荞݋
  
  // NbZ[W̕\
  // SCI3_OUT_STRING ("H8/3694F RS232 test \n");  //񑗐M֐
  
  do {
    // 7ZO\
    diag_num(mode,temp_d); 
       
    if(onoff)
    {
      // tONA
      onoff = 0;
      
      // ADϊ̕\
      get_temp();
      SCI3_PRINTF ("T = %d, Vo = %d, T2 = %d\r\n",temp_i,volt,temp);
      
      // ݒ胂[hȂ
      if(onset)
      {
        temp_d = temp_c;
        
        // Xgbv
        exec_relay(STOP);
        
        // _ŏ
        diag_num(0,15);
        twait(BWT);
      }else{
        // 
        if(temp_d < temp_c) {exec_relay(STOP);  }
        if(temp_d > temp_c) {exec_relay(BECOOL);}
      }
    } 
  }while(1);
  
  return 0;
}


void init()
{
  // H8/3664F 
  IO.PMR1.BYTE=0x00;                                            // S0ɃZbgA|[ggpɐݒ@0000 0000
  IO.PCR1  =0x00;                                               // S0ɃZbgA͂ɐݒ@ 
                                                                // PCRڼ޽́@IO.PCR1.BYTE@LqłȂI
  IO.PCR8 = 0xFF;                                               // LEDp|[g̐ݒ S1ZbgAo͂ɐݒ 
  IO.PCR5 = 0x3F;                                               // LEDp|[g̐ݒ S1ZbgAo͂ɐݒ 
  IO.PDR8.BIT.B0 = 1;
  IO.PDR8.BIT.B1 = 1;
  //SCI3.SCR3.BYTE = 0x30;   // 
  //SCI3.SCR3.BIT.TE = 1;   // M
  //SCI3.SCR3.BIT.RE = 1;   // M
  //SCI3.SSR.BYTE  &= 0x80;
  //SCI3.SMR.BYTE   = 0x00;
  
  //-----------------------
  // ^C}Aݒ 
  //-----------------------
  TA.TMA.BYTE=0x18;       /* I[o[t[1b */
  IRR1.BIT.IRRTA=0;       /* ^C}[`݃tÕZbg */
  IENR1.BIT.IENTA=1;      /* ^C}[`݂𗘗p\ɂ */
  
  AD.ADCSR.BYTE = 0x08;   /* 0000 1000*/
  /* A/Dϊ~ */
  /* Pꃂ[h */
  /* ϊ */
  /* AN0 */
  
  //-----------------------
  // 荞ݐݒ 
  //-----------------------
  IO.PMR1.BIT.IRQ0=1; /* P14IRQ0ɃZbg */ 
  IEGR1.BIT.IEG0=0; /* IRQ0̗GbWo */
  IRR1.BIT.IRRI0=0; /* IRQ0ݗvtONA */ 
  IENR1.BIT.IEN0=1; /* IRQ0݋ */ 
  
  IO.PMR1.BIT.IRQ1=1; /* P15IRQ1ɃZbg */ 
  IEGR1.BIT.IEG1=0; /* IRQ1̗GbWo */
  IRR1.BIT.IRRI1=0; /* IRQ1ݗvtONA */ 
  IENR1.BIT.IEN1=1; /* IRQ1݋ */ 
  
  IO.PMR1.BIT.IRQ2=1; /* P16IRQ2ɃZbg */ 
  IEGR1.BIT.IEG2=0; /* IRQ2̗GbWo */
  IRR1.BIT.IRRI2=0; /* IRQ2ݗvtONA */ 
  IENR1.BIT.IEN2=1; /* IRQ2݋ */ 
    
  SCI3_INIT(br19200, txb, sizeof(txb), rxb, sizeof(rxb));       // RS-232CʐM̏;
}


void twait(long time)
{
  long i;
  
  for (i = 0; i < time; i++);
}

void diag_num(int mode,int num)
{
  // 7LED \p֐
  char n0,n1;

  if(mode == 1)
  {
    n1 = (int)(num/10);
    n0 = num - n1*10;
       
    IO.PDR1.BIT.B0 = 1;
    IO.PDR1.BIT.B1 = 1;
    IO.PDR5.BYTE = 0x10 | (0x0F & n1);
    twait(TWT);
      
    IO.PDR1.BIT.B0 = 1;
    IO.PDR1.BIT.B1 = 1;
    IO.PDR5.BYTE = 0x20 | (0x0F & n0);
    twait(TWT);
  }else{
    IO.PDR1.BIT.B0 = 1;
    IO.PDR1.BIT.B1 = 1;
    
    IO.PDR5.BYTE = 0x10 | (0x0F & num);
    IO.PDR5.BYTE = 0x20 | (0x0F & num);
    twait(TWT);
  }
}

/* ^C}[`݊֐ */
void int_timera(void)
{
  IRR1.BIT.IRRTA=0;

  // tO𗧂Ă(1bu
  onoff = 1;
}

// O
void int_irq0(void)
{ 
  DI;
  IRR1.BIT.IRRI0=0;
  IENR1.BIT.IEN0=0;
  IENR1.BIT.IEN0=1; /* IRQ0݋ */
  
  //twait(TWT);
  if(onset) temp_c++;
  if(temp_c > 50) temp_c = 50;
      
  EI;
}
void int_irq1(void)
{ 
  DI;
  IRR1.BIT.IRRI1=0;
  IENR1.BIT.IEN1=0;
  IENR1.BIT.IEN1=1; /* IRQ1݋ */
  
  if(onset)
    onset = 0;
  else
    onset = 1;
    
  EI;
}
void int_irq2(void)
{ 
  DI;
  IRR1.BIT.IRRI2=0;
  IENR1.BIT.IEN2=0;
  IENR1.BIT.IEN2=1; /* IRQ0݋ */

  //twait(TWT);  
  if(onset) temp_c--;
  if(temp_c < 0) temp_c = 0;
  EI;
}

// A/D ϊ
void get_temp(void)
{
    AD.ADCSR.BIT.ADST = 1; /* A/DϊX^[g */
    while(AD.ADCSR.BIT.ADF==0); /* ϊʂł܂ő҂ */
    
    //temp = (unsigned short)(10000 - 50000/((double)(AD.ADDRA & 0x3FF)*dig - 1));
    volt = (AD.ADDRA >> 6)*dig*dof;
    temp_d  = temp = (double)volt/dof*SF + OF;
    //temp_s =  (int)(((double)(AD.ADDRA >> 6)*dig)*SF + OF)*dof;
    
    temp_i = ((double)volt/dof*SF + OF)*100;
    //temp_i = ((double)temp_s/dof)*dof;
    //temp_d = (double)temp_s/dof + 0.5;
    //temp_s = temp_s - temp_i;
    //temp_i =(double) temp_i/dof;
    
    if(temp_d > 100) temp_d = 99;
    
    return;
}

// [쓮
void exec_relay(char num)
{
      switch(num)
      {
        case 0: IO.PDR8.BIT.B0 = 1; IO.PDR8.BIT.B1 = 1; break;  // Stop
        case 1: IO.PDR8.BIT.B0 = 0; break;  // hot
        case 2: IO.PDR8.BIT.B1 = 0; break;  // cool

        case 5: IO.PDR8.BIT.B0 = 1; break;
        case 6: IO.PDR8.BIT.B1 = 1; break;

        case 7: IO.PDR8.BIT.B0 = 1; IO.PDR8.BIT.B1 = 1; break;  // Be Hot
        case 8: IO.PDR8.BIT.B0 = 0; IO.PDR8.BIT.B1 = 0; break;  // Be Cool
      };
}
